﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BarChartSelection
{
    public class ViewModel : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Implementation
        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion

        public EnergyProductionDataSample Data { get; set; }

        public ViewModel()
        {
            Data = new EnergyProductionDataSample();
        }
    }

    public class EnergyProductionDataSample : EnergyProductionData
    {
        public EnergyProductionDataSample()
        {
            this.Add(new EnergyProduction { Country = "Canada", Coal = 400, Oil = 100, Nuclear = 225, Hydro = 350 });
            this.Add(new EnergyProduction { Country = "China", Coal = 925, Oil = 200, Nuclear = 400, Hydro = 625 });
            this.Add(new EnergyProduction { Country = "Russia", Coal = 550, Oil = 200, Nuclear = 475, Hydro = 425 });
            this.Add(new EnergyProduction { Country = "Australia", Coal = 450, Oil = 100, Nuclear = 175, Hydro = 350 });
            this.Add(new EnergyProduction { Country = "United States", Coal = 800, Oil = 250, Nuclear = 575, Hydro = 750 });
            this.Add(new EnergyProduction { Country = "France", Coal = 375, Oil = 150, Nuclear = 275, Hydro = 325 });
        }
    }
    public class EnergyProductionData : ObservableCollection<EnergyProduction>
    {

    }
    public class EnergyProduction : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Implementation
        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion

        public string Country { get; set; }

        private double _nuclear;
        public double Nuclear
        {
            get { return _nuclear; }
            set { _nuclear = value; OnPropertyChanged("Nuclear"); }
        }
        private bool _nuclearSelected;
        public bool NuclearSelected
        {
            get { return _nuclearSelected; }
            set { _nuclearSelected = value; OnPropertyChanged("NuclearSelected"); }
        }

        private double _coal;
        public double Coal
        {
            get { return _coal; }
            set { _coal = value; OnPropertyChanged("Nuclear"); }
        }
        private bool _coalSelected;
        public bool CoalSelected
        {
            get { return _coalSelected; }
            set { _coalSelected = value; OnPropertyChanged("CoalSelected"); }
        }

        private double _oil;
        public double Oil
        {
            get { return _oil; }
            set { _oil = value; OnPropertyChanged("Nuclear"); }
        }
        private bool _oilSelected;
        public bool OilSelected
        {
            get { return _oilSelected; }
            set { _oilSelected = value; OnPropertyChanged("OilSelected"); }
        }

        private double _hydro;
        public double Hydro
        {
            get { return _hydro; }
            set { _hydro = value; OnPropertyChanged("Nuclear"); }
        }
        private bool _hydroSelected;
        public bool HydroSelected
        {
            get { return _hydroSelected; }
            set { _hydroSelected = value; OnPropertyChanged("HydroSelected"); }
        }

        public double Total
        {
            get
            {
                return Coal + Nuclear + Hydro + Oil;
            }
        }

        private bool _isSelected;
        public bool IsSelected
        {
            get { return _isSelected; }
            set { _isSelected = value; OnPropertyChanged("IsSelected"); }
        }
    }
}
